diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-http.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-http.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-http.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-http.php	2012-12-17 16:18:40.000000000 -0600
***************
*** 169,189 ****
  		if ( WP_Http_Encoding::is_available() )
  			$r['headers']['Accept-Encoding'] = WP_Http_Encoding::accept_encoding();
  
! 		if ( empty($r['body']) ) {
! 			$r['body'] = null;
! 			// Some servers fail when sending content without the content-length header being set.
! 			// Also, to fix another bug, we only send when doing POST and PUT and the content-length
! 			// header isn't already set.
! 			if ( ($r['method'] == 'POST' || $r['method'] == 'PUT') && ! isset( $r['headers']['Content-Length'] ) )
! 				$r['headers']['Content-Length'] = 0;
! 		} else {
  			if ( is_array( $r['body'] ) || is_object( $r['body'] ) ) {
  				$r['body'] = http_build_query( $r['body'], null, '&' );
  				if ( ! isset( $r['headers']['Content-Type'] ) )
  					$r['headers']['Content-Type'] = 'application/x-www-form-urlencoded; charset=' . get_option( 'blog_charset' );
- 				$r['headers']['Content-Length'] = strlen( $r['body'] );
  			}
  
  			if ( ! isset( $r['headers']['Content-Length'] ) && ! isset( $r['headers']['content-length'] ) )
  				$r['headers']['Content-Length'] = strlen( $r['body'] );
  		}
--- 169,185 ----
  		if ( WP_Http_Encoding::is_available() )
  			$r['headers']['Accept-Encoding'] = WP_Http_Encoding::accept_encoding();
  
! 		if ( ( ! is_null( $r['body'] ) && '' != $r['body'] ) || 'POST' == $r['method'] || 'PUT' == $r['method'] ) {
  			if ( is_array( $r['body'] ) || is_object( $r['body'] ) ) {
  				$r['body'] = http_build_query( $r['body'], null, '&' );
+ 
  				if ( ! isset( $r['headers']['Content-Type'] ) )
  					$r['headers']['Content-Type'] = 'application/x-www-form-urlencoded; charset=' . get_option( 'blog_charset' );
  			}
  
+ 			if ( '' === $r['body'] )
+ 				$r['body'] = null;
+ 
  			if ( ! isset( $r['headers']['Content-Length'] ) && ! isset( $r['headers']['content-length'] ) )
  				$r['headers']['Content-Length'] = strlen( $r['body'] );
  		}
***************
*** 200,206 ****
  	 * @param array $args Request arguments
  	 * @param string $url URL to Request
  	 *
! 	 * @return string|false Class name for the first transport that claims to support the request. False if no transport claims to support the request.
  	 */
  	public function _get_first_available_transport( $args, $url = null ) {
  		$request_order = array( 'curl', 'streams', 'fsockopen' );
--- 196,202 ----
  	 * @param array $args Request arguments
  	 * @param string $url URL to Request
  	 *
! 	 * @return string|bool Class name for the first transport that claims to support the request. False if no transport claims to support the request.
  	 */
  	public function _get_first_available_transport( $args, $url = null ) {
  		$request_order = array( 'curl', 'streams', 'fsockopen' );
***************
*** 382,399 ****
  
  			list($key, $value) = explode(':', $tempheader, 2);
  
! 			if ( !empty( $value ) ) {
! 				$key = strtolower( $key );
! 				if ( isset( $newheaders[$key] ) ) {
! 					if ( !is_array($newheaders[$key]) )
! 						$newheaders[$key] = array($newheaders[$key]);
! 					$newheaders[$key][] = trim( $value );
! 				} else {
! 					$newheaders[$key] = trim( $value );
! 				}
! 				if ( 'set-cookie' == $key )
! 					$cookies[] = new WP_Http_Cookie( $value );
  			}
  		}
  
  		return array('response' => $response, 'headers' => $newheaders, 'cookies' => $cookies);
--- 378,395 ----
  
  			list($key, $value) = explode(':', $tempheader, 2);
  
! 			$key = strtolower( $key );
! 			$value = trim( $value );
! 
! 			if ( isset( $newheaders[ $key ] ) ) {
! 				if ( ! is_array( $newheaders[ $key ] ) )
! 					$newheaders[$key] = array( $newheaders[ $key ] );
! 				$newheaders[ $key ][] = $value;
! 			} else {
! 				$newheaders[ $key ] = $value;
  			}
+ 			if ( 'set-cookie' == $key )
+ 				$cookies[] = new WP_Http_Cookie( $value );
  		}
  
  		return array('response' => $response, 'headers' => $newheaders, 'cookies' => $cookies);
***************
*** 429,434 ****
--- 425,432 ----
  	 * Based off the HTTP http_encoding_dechunk function. Does not support UTF-8. Does not support
  	 * returning footer headers. Shouldn't be too difficult to support it though.
  	 *
+ 	 * @link http://tools.ietf.org/html/rfc2616#section-19.4.6 Process for chunked decoding.
+ 	 *
  	 * @todo Add support for footer chunked headers.
  	 * @access public
  	 * @since 2.7.0
***************
*** 806,812 ****
  		if ( ! function_exists( 'fsockopen' ) )
  			return false;
  
! 		if ( false !== ($option = get_option( 'disable_fsockopen' )) && time()-$option < 43200 ) // 12 hours
  			return false;
  
  		$is_ssl = isset( $args['ssl'] ) && $args['ssl'];
--- 804,810 ----
  		if ( ! function_exists( 'fsockopen' ) )
  			return false;
  
! 		if ( false !== ( $option = get_option( 'disable_fsockopen' ) ) && time() - $option < 12 * HOUR_IN_SECONDS )
  			return false;
  
  		$is_ssl = isset( $args['ssl'] ) && $args['ssl'];
***************
*** 912,918 ****
  				$arrContext['http']['header'] .= $proxy->authentication_header() . "\r\n";
  		}
  
! 		if ( ! empty($r['body'] ) )
  			$arrContext['http']['content'] = $r['body'];
  
  		$context = stream_context_create($arrContext);
--- 910,916 ----
  				$arrContext['http']['header'] .= $proxy->authentication_header() . "\r\n";
  		}
  
! 		if ( ! is_null( $r['body'] ) )
  			$arrContext['http']['content'] = $r['body'];
  
  		$context = stream_context_create($arrContext);
***************
*** 1105,1117 ****
  				break;
  			default:
  				curl_setopt( $handle, CURLOPT_CUSTOMREQUEST, $r['method'] );
! 				if ( ! empty( $r['body'] ) )
  					curl_setopt( $handle, CURLOPT_POSTFIELDS, $r['body'] );
  				break;
  		}
  
  		if ( true === $r['blocking'] )
! 			curl_setopt( $handle, CURLOPT_HEADERFUNCTION, array( &$this, 'stream_headers' ) );
  
  		curl_setopt( $handle, CURLOPT_HEADER, false );
  
--- 1103,1115 ----
  				break;
  			default:
  				curl_setopt( $handle, CURLOPT_CUSTOMREQUEST, $r['method'] );
! 				if ( ! is_null( $r['body'] ) )
  					curl_setopt( $handle, CURLOPT_POSTFIELDS, $r['body'] );
  				break;
  		}
  
  		if ( true === $r['blocking'] )
! 			curl_setopt( $handle, CURLOPT_HEADERFUNCTION, array( $this, 'stream_headers' ) );
  
  		curl_setopt( $handle, CURLOPT_HEADER, false );
  
***************
*** 1392,1397 ****
--- 1390,1399 ----
  
  		$home = parse_url( get_option('siteurl') );
  
+ 		$result = apply_filters( 'pre_http_send_through_proxy', null, $uri, $check, $home );
+ 		if ( ! is_null( $result ) )
+ 			return $result;
+ 
  		if ( $check['host'] == 'localhost' || $check['host'] == $home['host'] )
  			return false;
  
***************
*** 1546,1552 ****
  	 */
  	function test( $url ) {
  		// Expires - if expired then nothing else matters
! 		if ( time() > $this->expires )
  			return false;
  
  		// Get details on the URL we're thinking about sending to
--- 1548,1554 ----
  	 */
  	function test( $url ) {
  		// Expires - if expired then nothing else matters
! 		if ( isset( $this->expires ) && time() > $this->expires )
  			return false;
  
  		// Get details on the URL we're thinking about sending to
***************
*** 1586,1592 ****
  	 * @return string Header encoded cookie name and value.
  	 */
  	function getHeaderValue() {
! 		if ( empty( $this->name ) || empty( $this->value ) )
  			return '';
  
  		return $this->name . '=' . apply_filters( 'wp_http_cookie_value', $this->value, $this->name );
--- 1588,1594 ----
  	 * @return string Header encoded cookie name and value.
  	 */
  	function getHeaderValue() {
! 		if ( ! isset( $this->name ) || ! isset( $this->value ) )
  			return '';
  
  		return $this->name . '=' . apply_filters( 'wp_http_cookie_value', $this->value, $this->name );
***************
*** 1673,1679 ****
  	/**
  	 * Decompression of deflated string while staying compatible with the majority of servers.
  	 *
! 	 * Certain Servers will return deflated data with headers which PHP's gziniflate()
  	 * function cannot handle out of the box. The following function has been created from
  	 * various snippets on the gzinflate() PHP documentation.
  	 *
--- 1675,1681 ----
  	/**
  	 * Decompression of deflated string while staying compatible with the majority of servers.
  	 *
! 	 * Certain Servers will return deflated data with headers which PHP's gzinflate()
  	 * function cannot handle out of the box. The following function has been created from
  	 * various snippets on the gzinflate() PHP documentation.
  	 *
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-IXR.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-IXR.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-IXR.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-IXR.php	2012-12-17 16:18:40.000000000 -0600
***************
*** 466,476 ****
  
      function output($xml)
      {
!         $xml = '<?xml version="1.0"?>'."\n".$xml;
          $length = strlen($xml);
          header('Connection: close');
          header('Content-Length: '.$length);
!         header('Content-Type: text/xml');
          header('Date: '.date('r'));
          echo $xml;
          exit;
--- 466,483 ----
  
      function output($xml)
      {
!         $charset = function_exists('get_option') ? get_option('blog_charset') : '';
!         if ($charset)
!             $xml = '<?xml version="1.0" encoding="'.$charset.'"?>'."\n".$xml;
!         else
!             $xml = '<?xml version="1.0"?>'."\n".$xml;
          $length = strlen($xml);
          header('Connection: close');
          header('Content-Length: '.$length);
!         if ($charset)
!             header('Content-Type: text/xml; charset='.$charset);
!         else
!             header('Content-Type: text/xml');
          header('Date: '.date('r'));
          echo $xml;
          exit;
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-oembed.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-oembed.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-oembed.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-oembed.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 30,57 ****
  		// The WP_Embed class disables discovery for non-unfiltered_html users, so only providers in this array will be used for them.
  		// Add to this list using the wp_oembed_add_provider() function (see its PHPDoc for details).
  		$this->providers = apply_filters( 'oembed_providers', array(
! 			'#http://(www\.)?youtube.com/watch.*#i'              => array( 'http://www.youtube.com/oembed',                     true  ),
  			'http://youtu.be/*'                                  => array( 'http://www.youtube.com/oembed',                     false ),
  			'http://blip.tv/*'                                   => array( 'http://blip.tv/oembed/',                            false ),
! 			'#http://(www\.)?vimeo\.com/.*#i'                    => array( 'http://vimeo.com/api/oembed.{format}',              true  ),
! 			'#http://(www\.)?dailymotion\.com/.*#i'              => array( 'http://www.dailymotion.com/services/oembed',        true  ),
! 			'#http://(www\.)?flickr\.com/.*#i'                   => array( 'http://www.flickr.com/services/oembed/',            true  ),
! 			'#http://(.+\.)?smugmug\.com/.*#i'                   => array( 'http://api.smugmug.com/services/oembed/',           true  ),
! 			'#http://(www\.)?hulu\.com/watch/.*#i'               => array( 'http://www.hulu.com/api/oembed.{format}',           true  ),
! 			'#http://(www\.)?viddler\.com/.*#i'                  => array( 'http://lab.viddler.com/services/oembed/',           true  ),
  			'http://qik.com/*'                                   => array( 'http://qik.com/api/oembed.{format}',                false ),
  			'http://revision3.com/*'                             => array( 'http://revision3.com/api/oembed/',                  false ),
  			'http://i*.photobucket.com/albums/*'                 => array( 'http://photobucket.com/oembed',                     false ),
  			'http://gi*.photobucket.com/groups/*'                => array( 'http://photobucket.com/oembed',                     false ),
! 			'#http://(www\.)?scribd\.com/.*#i'                   => array( 'http://www.scribd.com/services/oembed',             true  ),
  			'http://wordpress.tv/*'                              => array( 'http://wordpress.tv/oembed/',                       false ),
! 			'#http://(.+\.)?polldaddy\.com/.*#i'                 => array( 'http://polldaddy.com/oembed/',                      true  ),
! 			'#http://(www\.)?funnyordie\.com/videos/.*#i'        => array( 'http://www.funnyordie.com/oembed',                  true  ),
  			'#https?://(www\.)?twitter.com/.+?/status(es)?/.*#i' => array( 'http://api.twitter.com/1/statuses/oembed.{format}', true  ),
  		) );
  
  		// Fix any embeds that contain new lines in the middle of the HTML which breaks wpautop().
! 		add_filter( 'oembed_dataparse', array(&$this, '_strip_newlines'), 10, 3 );
  	}
  
  	/**
--- 30,60 ----
  		// The WP_Embed class disables discovery for non-unfiltered_html users, so only providers in this array will be used for them.
  		// Add to this list using the wp_oembed_add_provider() function (see its PHPDoc for details).
  		$this->providers = apply_filters( 'oembed_providers', array(
! 			'#https?://(www\.)?youtube.com/watch.*#i'            => array( 'http://www.youtube.com/oembed',                     true  ),
  			'http://youtu.be/*'                                  => array( 'http://www.youtube.com/oembed',                     false ),
  			'http://blip.tv/*'                                   => array( 'http://blip.tv/oembed/',                            false ),
! 			'#https?://(www\.)?vimeo\.com/.*#i'                  => array( 'http://vimeo.com/api/oembed.{format}',              true  ),
! 			'#https?://(www\.)?dailymotion\.com/.*#i'            => array( 'http://www.dailymotion.com/services/oembed',        true  ),
! 			'#https?://(www\.)?flickr\.com/.*#i'                 => array( 'http://www.flickr.com/services/oembed/',            true  ),
! 			'#https?://(.+\.)?smugmug\.com/.*#i'                 => array( 'http://api.smugmug.com/services/oembed/',           true  ),
! 			'#https?://(www\.)?hulu\.com/watch/.*#i'             => array( 'http://www.hulu.com/api/oembed.{format}',           true  ),
! 			'#https?://(www\.)?viddler\.com/.*#i'                => array( 'http://lab.viddler.com/services/oembed/',           true  ),
  			'http://qik.com/*'                                   => array( 'http://qik.com/api/oembed.{format}',                false ),
  			'http://revision3.com/*'                             => array( 'http://revision3.com/api/oembed/',                  false ),
  			'http://i*.photobucket.com/albums/*'                 => array( 'http://photobucket.com/oembed',                     false ),
  			'http://gi*.photobucket.com/groups/*'                => array( 'http://photobucket.com/oembed',                     false ),
! 			'#https?://(www\.)?scribd\.com/.*#i'                 => array( 'http://www.scribd.com/services/oembed',             true  ),
  			'http://wordpress.tv/*'                              => array( 'http://wordpress.tv/oembed/',                       false ),
! 			'#https?://(.+\.)?polldaddy\.com/.*#i'               => array( 'http://polldaddy.com/oembed/',                      true  ),
! 			'#https?://(www\.)?funnyordie\.com/videos/.*#i'      => array( 'http://www.funnyordie.com/oembed',                  true  ),
  			'#https?://(www\.)?twitter.com/.+?/status(es)?/.*#i' => array( 'http://api.twitter.com/1/statuses/oembed.{format}', true  ),
+  			'#https?://(www\.)?soundcloud\.com/.*#i'             => array( 'http://soundcloud.com/oembed',                      true  ),
+ 			'#https?://(www\.)?slideshare.net/*#'                => array( 'http://www.slideshare.net/api/oembed/2',            true  ),
+ 			'#http://instagr(\.am|am\.com)/p/.*#i'               => array( 'http://api.instagram.com/oembed',                   true  ),
  		) );
  
  		// Fix any embeds that contain new lines in the middle of the HTML which breaks wpautop().
! 		add_filter( 'oembed_dataparse', array($this, '_strip_newlines'), 10, 3 );
  	}
  
  	/**
***************
*** 75,82 ****
  			list( $providerurl, $regex ) = $data;
  
  			// Turn the asterisk-type provider URLs into regex
! 			if ( !$regex )
  				$matchmask = '#' . str_replace( '___wildcard___', '(.+)', preg_quote( str_replace( '*', '___wildcard___', $matchmask ), '#' ) ) . '#i';
  
  			if ( preg_match( $matchmask, $url ) ) {
  				$provider = str_replace( '{format}', 'json', $providerurl ); // JSON is easier to deal with than XML
--- 78,87 ----
  			list( $providerurl, $regex ) = $data;
  
  			// Turn the asterisk-type provider URLs into regex
! 			if ( !$regex ) {
  				$matchmask = '#' . str_replace( '___wildcard___', '(.+)', preg_quote( str_replace( '*', '___wildcard___', $matchmask ), '#' ) ) . '#i';
+ 				$matchmask = preg_replace( '|^#http\\\://|', '#https?\://', $matchmask );
+ 			}
  
  			if ( preg_match( $matchmask, $url ) ) {
  				$provider = str_replace( '{format}', 'json', $providerurl ); // JSON is easier to deal with than XML
***************
*** 163,168 ****
--- 168,175 ----
  		$provider = add_query_arg( 'maxheight', (int) $args['height'], $provider );
  		$provider = add_query_arg( 'url', urlencode($url), $provider );
  
+ 		$provider = apply_filters( 'oembed_fetch_url', $provider, $url, $args );
+ 
  		foreach( array( 'json', 'xml' ) as $format ) {
  			$result = $this->_fetch_with_format( $provider, $format );
  			if ( is_wp_error( $result ) && 'not-implemented' == $result->get_error_code() )
***************
*** 209,228 ****
  	 * @access private
  	 */
  	function _parse_xml( $response_body ) {
! 		if ( function_exists('simplexml_load_string') ) {
! 			$errors = libxml_use_internal_errors( 'true' );
! 			$data = simplexml_load_string( $response_body );
! 			libxml_use_internal_errors( $errors );
! 			if ( ! is_object( $data ) )
! 				return false;
! 
! 			$return = new stdClass;
! 			foreach ( $data as $key => $value )
! 				$return->$key = (string) $value;
  
! 			return $return;
  		}
! 		return false;
  	}
  
  	/**
--- 216,254 ----
  	 * @access private
  	 */
  	function _parse_xml( $response_body ) {
! 		if ( !function_exists('simplexml_load_string') ) {
! 			return false;
! 		}
  
! 		if ( ! class_exists( 'DOMDocument' ) )
! 			return false;
! 
! 		$errors = libxml_use_internal_errors( true );
! 		$old_value = null;
! 		if ( function_exists( 'libxml_disable_entity_loader' ) ) {
! 			$old_value = libxml_disable_entity_loader( true );
  		}
! 
! 		$dom = new DOMDocument;
! 		$success = $dom->loadXML( $response_body );
! 
! 		if ( ! is_null( $old_value ) ) {
! 			libxml_disable_entity_loader( $old_value );
! 		}
! 		libxml_use_internal_errors( $errors );
! 
! 		if ( ! $success || isset( $dom->doctype ) ) {
! 			return false;
! 		}
! 
! 		$data = simplexml_import_dom( $dom );
! 		if ( ! is_object( $data ) )
! 			return false;
! 
! 		$return = new stdClass;
! 		foreach ( $data as $key => $value )
! 			$return->$key = (string) $value;
! 		return $return;
  	}
  
  	/**
***************
*** 296,302 ****
   *
   * @return WP_oEmbed object.
   */
! function &_wp_oembed_get_object() {
  	static $wp_oembed;
  
  	if ( is_null($wp_oembed) )
--- 322,328 ----
   *
   * @return WP_oEmbed object.
   */
! function _wp_oembed_get_object() {
  	static $wp_oembed;
  
  	if ( is_null($wp_oembed) )
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-admin-bar.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-admin-bar.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-admin-bar.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-admin-bar.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 1,4 ****
--- 1,12 ----
  <?php
+ /**
+  * The WordPress Toolbar
+  *
+  * @since 3.1.0
+  *
+  * @package WordPress
+  * @subpackage Toolbar
+  */
  class WP_Admin_Bar {
  	private $nodes = array();
  	private $bound = false;
***************
*** 104,110 ****
  			$defaults = get_object_vars( $maybe_defaults );
  
  		// Do the same for 'meta' items.
! 		if ( ! empty( $defaults['meta'] ) && empty( $args['meta'] ) )
  			$args['meta'] = wp_parse_args( $args['meta'], $defaults['meta'] );
  
  		$args = wp_parse_args( $args, $defaults );
--- 112,118 ----
  			$defaults = get_object_vars( $maybe_defaults );
  
  		// Do the same for 'meta' items.
! 		if ( ! empty( $defaults['meta'] ) && ! empty( $args['meta'] ) )
  			$args['meta'] = wp_parse_args( $args['meta'], $defaults['meta'] );
  
  		$args = wp_parse_args( $args, $defaults );
***************
*** 149,161 ****
  	}
  
  	final public function get_nodes() {
! 	   if ( ! $nodes = $this->_get_nodes() )
! 	      return;
  
! 	   foreach ( $nodes as &$node ) {
! 	       $node = clone $node;
! 	   }
! 	   return $nodes;
  	}
  
  	final protected function _get_nodes() {
--- 157,169 ----
  	}
  
  	final public function get_nodes() {
! 		if ( ! $nodes = $this->_get_nodes() )
! 			return;
  
! 		foreach ( $nodes as &$node ) {
! 			$node = clone $node;
! 		}
! 		return $nodes;
  	}
  
  	final protected function _get_nodes() {
***************
*** 184,190 ****
  	/**
  	 * Remove a node.
  	 *
! 	 * @return object The removed node.
  	 */
  	public function remove_node( $id ) {
  		$this->_unset_node( $id );
--- 192,198 ----
  	/**
  	 * Remove a node.
  	 *
! 	 * @param string The ID of the item.
  	 */
  	public function remove_node( $id ) {
  		$this->_unset_node( $id );
***************
*** 237,244 ****
  
  			if ( $node->type == 'group' ) {
  				if ( empty( $node->meta['class'] ) )
! 					$node->meta['class'] = '';
! 				$node->meta['class'] .= ' ' . $group_class;
  			}
  
  			// Items in items aren't allowed. Wrap nested items in 'default' groups.
--- 245,253 ----
  
  			if ( $node->type == 'group' ) {
  				if ( empty( $node->meta['class'] ) )
! 					$node->meta['class'] = $group_class;
! 				else
! 					$node->meta['class'] .= ' ' . $group_class;
  			}
  
  			// Items in items aren't allowed. Wrap nested items in 'default' groups.
***************
*** 339,349 ****
  
  		?>
  		<div id="wpadminbar" class="<?php echo $class; ?>" role="navigation">
! 			<div class="quicklinks">
  				<?php foreach ( $root->children as $group ) {
  					$this->_render_group( $group );
  				} ?>
  			</div>
  		</div>
  
  		<?php
--- 348,360 ----
  
  		?>
  		<div id="wpadminbar" class="<?php echo $class; ?>" role="navigation">
! 			<a class="screen-reader-shortcut" href="#wp-toolbar" tabindex="1"><?php _e('Skip to toolbar'); ?></a>
! 			<div class="quicklinks" id="wp-toolbar" role="navigation" aria-label="<?php esc_attr_e('Top navigation toolbar.'); ?>" tabindex="0">
  				<?php foreach ( $root->children as $group ) {
  					$this->_render_group( $group );
  				} ?>
  			</div>
+ 			<a class="screen-reader-shortcut" href="<?php echo esc_url( wp_logout_url() ); ?>"><?php _e('Log Out'); ?></a>
  		</div>
  
  		<?php
***************
*** 367,375 ****
  		if ( $node->type != 'group' || empty( $node->children ) )
  			return;
  
! 		$class = empty( $node->meta['class'] ) ? '' : $node->meta['class'];
  
! 		?><ul id="<?php echo esc_attr( 'wp-admin-bar-' . $node->id ); ?>" class="<?php echo esc_attr( $class ); ?>"><?php
  			foreach ( $node->children as $item ) {
  				$this->_render_item( $item );
  			}
--- 378,389 ----
  		if ( $node->type != 'group' || empty( $node->children ) )
  			return;
  
! 		if ( ! empty( $node->meta['class'] ) )
! 			$class = ' class="' . esc_attr( trim( $node->meta['class'] ) ) . '"';
! 		else
! 			$class = '';
  
! 		?><ul id="<?php echo esc_attr( 'wp-admin-bar-' . $node->id ); ?>"<?php echo $class; ?>><?php
  			foreach ( $node->children as $item ) {
  				$this->_render_item( $item );
  			}
***************
*** 383,404 ****
  		$is_parent = ! empty( $node->children );
  		$has_link  = ! empty( $node->href );
  
! 		$tabindex = isset( $node->meta['tabindex'] ) ? (int) $node->meta['tabindex'] : 10;
  
  		$menuclass = '';
- 		$aria_attributes = 'tabindex="' . $tabindex . '"';
  
  		if ( $is_parent ) {
! 			$menuclass = 'menupop';
  			$aria_attributes .= ' aria-haspopup="true"';
  		}
  
  		if ( ! empty( $node->meta['class'] ) )
! 			$menuclass .= ' ' . $node->meta['class'];
  
  		?>
  
! 		<li id="<?php echo esc_attr( 'wp-admin-bar-' . $node->id ); ?>" class="<?php echo esc_attr( $menuclass ); ?>"><?php
  			if ( $has_link ):
  				?><a class="ab-item" <?php echo $aria_attributes; ?> href="<?php echo esc_url( $node->href ) ?>"<?php
  					if ( ! empty( $node->meta['onclick'] ) ) :
--- 397,421 ----
  		$is_parent = ! empty( $node->children );
  		$has_link  = ! empty( $node->href );
  
! 		$tabindex = isset( $node->meta['tabindex'] ) ? (int) $node->meta['tabindex'] : '';
! 		$aria_attributes = $tabindex ? 'tabindex="' . $tabindex . '"' : '';
  
  		$menuclass = '';
  
  		if ( $is_parent ) {
! 			$menuclass = 'menupop ';
  			$aria_attributes .= ' aria-haspopup="true"';
  		}
  
  		if ( ! empty( $node->meta['class'] ) )
! 			$menuclass .= $node->meta['class'];
! 
! 		if ( $menuclass )
! 			$menuclass = ' class="' . esc_attr( trim( $menuclass ) ) . '"';
  
  		?>
  
! 		<li id="<?php echo esc_attr( 'wp-admin-bar-' . $node->id ); ?>"<?php echo $menuclass; ?>><?php
  			if ( $has_link ):
  				?><a class="ab-item" <?php echo $aria_attributes; ?> href="<?php echo esc_url( $node->href ) ?>"<?php
  					if ( ! empty( $node->meta['onclick'] ) ) :
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-ajax-response.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-ajax-response.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-ajax-response.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-ajax-response.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 126,133 ****
  	 * @since 2.1.0
  	 */
  	function send() {
! 		header('Content-Type: text/xml');
! 		echo "<?xml version='1.0' standalone='yes'?><wp_ajax>";
  		foreach ( (array) $this->responses as $response )
  			echo $response;
  		echo '</wp_ajax>';
--- 126,133 ----
  	 * @since 2.1.0
  	 */
  	function send() {
! 		header( 'Content-Type: text/xml; charset=' . get_option( 'blog_charset' ) );
! 		echo "<?xml version='1.0' encoding='" . get_option( 'blog_charset' ) . "' standalone='yes'?><wp_ajax>";
  		foreach ( (array) $this->responses as $response )
  			echo $response;
  		echo '</wp_ajax>';
